/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.community.agency.wrapper;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import net.logstash.logback.encoder.org.apache.commons.lang3.StringUtils;
import org.springblade.community.agency.entity.Agency;
import org.springblade.community.agency.vo.AgencyVO;
import org.springblade.community.applyuser.entity.ApplyUser;
import org.springblade.community.applyuser.vo.ApplyUserVO;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.modules.system.service.IDeptService;
import org.springblade.sysarea.entity.SysArea;
import org.springblade.sysarea.service.ISysAreaService;
import org.springblade.system.street.entity.Street;
import org.springblade.system.street.service.IStreetService;

import java.util.Objects;

/**
 * 包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2020-11-06
 */
public class AgencyWrapper extends BaseEntityWrapper<Agency, AgencyVO> {

	private IStreetService streetService;
	private ISysAreaService sysAreaService;

	private AgencyWrapper(IStreetService streetService,ISysAreaService sysAreaService){
		this.streetService = streetService;
		this.sysAreaService = sysAreaService;
	}

	public static AgencyWrapper build(IStreetService streetService,ISysAreaService sysAreaService) {
		return new AgencyWrapper(streetService,sysAreaService);
 	}

	@Override
	public AgencyVO entityVO(Agency agency) {
		AgencyVO agencyVO = Objects.requireNonNull(BeanUtil.copy(agency, AgencyVO.class));

		SysArea province = sysAreaService.getBaseMapper().selectOne(new QueryWrapper<>(new SysArea()).lambda().eq(SysArea::getSCode, agency.getRegionProvince()));
		if(province != null){
			agencyVO.setProvinceName(province.getSName());
		}

		SysArea city = sysAreaService.getBaseMapper().selectOne(new QueryWrapper<>(new SysArea()).lambda().eq(SysArea::getSCode, agency.getRegionCity()));
		if(province != null){
			agencyVO.setCityName(city.getSName());
		}

		SysArea area = sysAreaService.getBaseMapper().selectOne(new QueryWrapper<>(new SysArea()).lambda().eq(SysArea::getSCode, agency.getRegionArea()));
		if(province != null){
			agencyVO.setAreaName(area.getSName());
		}

		Street street = streetService.getBaseMapper().selectOne(new QueryWrapper<>(new Street()).lambda().eq(Street::getCode,agency.getRegionStreet()));
		if(street != null){
			agencyVO.setStreetName(street.getName());
		}
		return agencyVO;
	}

}
